
#include "stdafx.h"
#include "MidiGalaxy.h"
#include "GGame.h"

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9d.lib")

#define MAX_LOADSTRING 100

//  
HWND g_hWnd;
HINSTANCE g_hInst;
TCHAR szTitle[MAX_LOADSTRING];					
TCHAR szWindowClass[MAX_LOADSTRING];


LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_MIDIGALAXY, szWindowClass, MAX_LOADSTRING);
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MIDIGALAXY));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	RegisterClassEx(&wcex);
	g_hInst = hInstance;
	g_hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
	  CW_USEDEFAULT, 0, 804, 695, NULL, NULL, hInstance, NULL);
	if (!g_hWnd) return FALSE;
	ShowWindow(g_hWnd, nCmdShow);
	UpdateWindow(g_hWnd);

	GGame &game=*GGame::GetInstance();
	
	game.m_dev.d3ddt=D3DDEVTYPE_HAL;
	game.m_dev.fullscreen=false;
	game.m_dev.backformat=D3DFMT_A8R8G8B8;
	game.m_dev.d3dse=D3DSWAPEFFECT_DISCARD;
	game.m_dev.buffercount=2;
	game.m_dev.width=800;
	game.m_dev.height=600;
	game.m_dev.stencilformat=D3DFMT_UNKNOWN;
	game.Create3DDevice(g_hWnd);
	game.MessageLoop();
	return 0;
}


LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	}
	return GGame::GetInstance()->MsgProc(hWnd, message, wParam, lParam);
}
